scala.tools.nsc.backend.jvm.BCodeHelpers

# JMirrorBuilder

###
Related Doc: package BCodeHelpers

#### class JMirrorBuilder extends JCommonBuilder

Source
  BCodeHelpers.scala

Linear Supertypes
JCommonBuilder, BCPickles, BCForwardersGen, BCJGenSigGen, BCAnnotGen, BCInnerClassGen, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. JMirrorBuilder
2. JCommonBuilder
3. BCPickles
4. BCForwardersGen
5. BCJGenSigGen
6. BCAnnotGen
7. BCInnerClassGen
8. AnyRef
9. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new JMirrorBuilder()

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from JMirrorBuilder to any2stringadd[JMirrorBuilder] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (JMirrorBuilder, B)

   Implicit information
     This member is added by an implicit conversion from JMirrorBuilder to ArrowAssoc[JMirrorBuilder] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def addForwarders(isRemoteClass: Boolean, jclass: ClassVisitor, jclassName: String, moduleClass: Global.Symbol): Unit

   Definition Classes
     BCForwardersGen

7. #### def addRemoteExceptionAnnot(isRemoteClass: Boolean, isJMethodPublic: Boolean, meth: Global.Symbol): Unit

   Definition Classes
     BCForwardersGen

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### final def asmMethodType(msym: Global.Symbol): BTypesFromSymbols.MethodBType

   Definition Classes
     BCInnerClassGen

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

11. #### def createJAttribute(name: String, b: Array[Byte], offset: Int, len: Int): Attribute

    Definition Classes
      BCPickles

12. #### def debugLevel: Int

    Definition Classes
      BCInnerClassGen

13. #### final def descriptor(sym: Global.Symbol): String

    The jvm descriptor for a symbol.

    The jvm descriptor for a symbol. If `sym` represents a nested class, its ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

14. #### final def descriptor(t: Global.Type): String

    The jvm descriptor of a type.

    The jvm descriptor of a type. If `t` references a nested class, its ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

15. #### def emitAnnotations(fw: FieldVisitor, annotations: List[Global.AnnotationInfo]): Unit

    Definition Classes
      BCAnnotGen

16. #### def emitAnnotations(mw: MethodVisitor, annotations: List[Global.AnnotationInfo]): Unit

    Definition Classes
      BCAnnotGen

17. #### def emitAnnotations(cw: ClassVisitor, annotations: List[Global.AnnotationInfo]): Unit

    Definition Classes
      BCAnnotGen

18. #### def emitArgument(av: AnnotationVisitor, name: String, arg: Global.ClassfileAnnotArg): Unit

    Definition Classes
      BCAnnotGen

19. #### def emitAssocs(av: AnnotationVisitor, assocs: List[(Global.Name, Global.ClassfileAnnotArg)]): Unit

    Definition Classes
      BCAnnotGen

20. #### final val emitLines: Boolean

    Definition Classes
      BCInnerClassGen

21. #### def emitParamAnnotations(jmethod: MethodVisitor, pannotss: List[List[Global.AnnotationInfo]]): Unit

    Definition Classes
      BCAnnotGen

22. #### final val emitSource: Boolean

    Definition Classes
      BCInnerClassGen

23. #### final val emitVars: Boolean

    Definition Classes
      BCInnerClassGen

24. #### def ensuring(cond: (JMirrorBuilder) ⇒ Boolean, msg: ⇒ Any): JMirrorBuilder

    Implicit information
      This member is added by an implicit conversion from JMirrorBuilder to Ensuring[JMirrorBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

25. #### def ensuring(cond: (JMirrorBuilder) ⇒ Boolean): JMirrorBuilder

    Implicit information
      This member is added by an implicit conversion from JMirrorBuilder to Ensuring[JMirrorBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

26. #### def ensuring(cond: Boolean, msg: ⇒ Any): JMirrorBuilder

    Implicit information
      This member is added by an implicit conversion from JMirrorBuilder to Ensuring[JMirrorBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### def ensuring(cond: Boolean): JMirrorBuilder

    Implicit information
      This member is added by an implicit conversion from JMirrorBuilder to Ensuring[JMirrorBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

28. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

29. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

30. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

31. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from JMirrorBuilder to StringFormat[JMirrorBuilder] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

32. #### def genMirrorClass(moduleClass: Global.Symbol, cunit: Global.CompilationUnit): ClassNode

33. #### def getAnnotPickle(jclassName: String, sym: Global.Symbol): Option[Global.AnnotationInfo]

    Definition Classes
      BCPickles

34. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

35. #### final def getClassBTypeAndRegisterInnerClass(sym: Global.Symbol): BTypesFromSymbols.ClassBType

    The ClassBType for a class symbol.

    The ClassBType for a class symbol. If the class is nested, the ClassBType is added to the innerClassBufferASM.

    The class symbol scala.Nothing is mapped to the class scala.runtime.Nothing$. Similarly, scala.Null is mapped to scala.runtime.Null$. This is because there exist no class files for the Nothing / Null. If used for example as a parameter type, we use the runtime classes in the classfile method signature.

    Note that the referenced class symbol may be an implementation class. For example when compiling a mixed-in method that forwards to the static method in the implementation class, the class descriptor of the receiver (the implementation class) is obtained by creating the ClassBType.

    Definition Classes
      BCInnerClassGen

36. #### def getCurrentCUnit(): Global.CompilationUnit

    Definition Classes
      JMirrorBuilder → BCJGenSigGen

37. #### def getExceptions(excs: List[Global.AnnotationInfo]): List[String]

    Definition Classes
      BCForwardersGen

38. #### def getGenericSignature(sym: Global.Symbol, owner: Global.Symbol): String

    Definition Classes
      BCJGenSigGen

39. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

40. #### final val innerClassBufferASM: Set[BTypesFromSymbols.ClassBType]

    Definition Classes
      BCInnerClassGen

41. #### final def internalName(sym: Global.Symbol): String

    The class internal name for a given class symbol.

    The class internal name for a given class symbol. If the symbol describes a nested class, the ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

42. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

43. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

44. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

45. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

46. #### def pickleMarkerForeign: Attribute

    Definition Classes
      BCPickles

47. #### def pickleMarkerLocal: Attribute

    Definition Classes
      BCPickles

48. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

49. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

50. #### final def toTypeKind(t: Global.Type): BTypesFromSymbols.BType

    This method returns the BType for a type reference, for example a parameter type.

    This method returns the BType for a type reference, for example a parameter type.

    If the result is a ClassBType for a nested class, it is added to the innerClassBufferASM.

    If `t` references a class, toTypeKind ensures that the class is not an implementation class. See also comment on getClassBTypeAndRegisterInnerClass, which is invoked for implementation classes.

    Definition Classes
      BCInnerClassGen

51. #### val versionPickle: PickleBuffer

    Definition Classes
      BCPickles

52. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

53. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

54. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

55. #### def →[B](y: B): (JMirrorBuilder, B)

    Implicit information
      This member is added by an implicit conversion from JMirrorBuilder to ArrowAssoc[JMirrorBuilder] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from JCommonBuilder

### Inherited from BCPickles

### Inherited from BCForwardersGen

### Inherited from BCJGenSigGen

### Inherited from BCAnnotGen

### Inherited from BCInnerClassGen

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from JMirrorBuilder to any2stringadd[JMirrorBuilder]

### Inherited by implicit conversion StringFormat from JMirrorBuilder to StringFormat[JMirrorBuilder]

### Inherited by implicit conversion Ensuring from JMirrorBuilder to Ensuring[JMirrorBuilder]

### Inherited by implicit conversion ArrowAssoc from JMirrorBuilder to ArrowAssoc[JMirrorBuilder]

### Ungrouped